// Charactor.cpp: CCharactor NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Charactor.h"

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

int CCharactor::EarthHeight = 400;
RECT CCharactor::FieldRect = {0,0,640,480};
CDirectSoundBuffer* CCharactor::pBoon;

CCharactor::CCharactor()
{
	m_pSurf = NULL;
}

CCharactor::~CCharactor()
{
	if( m_pSurf!=NULL )
		delete m_pSurf;
}

void CCharactor::Init( CHARATYPE DefType,double Speed , double JumpPower , double Gravity , char* pName ,
						const char* pBmpName , CDirectDraw* pDD)
{
	m_DefType = DefType;
	m_Speed = Speed;
	m_Jump = JumpPower;
	m_Gravity = Gravity;
	strcpy(m_Name,pName);

	if( m_pSurf!=NULL )
		delete m_pSurf;
	m_pSurf = new CDirectDrawSurface;
	pDD->CreateSurface(m_pSurf,pBmpName);
	m_pSurf->SetColorKey(RGB(0,0,0));
}

void CCharactor::StartGame(CHARATYPE type, int side)
{
	int x;
	if( side==0 )
		x = FieldRect.left + (FieldRect.right-FieldRect.left)/8;
	else
		x = FieldRect.right - (FieldRect.right-FieldRect.left)/8;
	m_Place[side] = CVector( x,EarthHeight-50,0 );
	m_VVelocity[side] = rand()%600;
	if( type==DEFAULT )
		m_Type[side] = m_DefType;
	else
		m_Type[side] = type;
}

void CCharactor::CopyInfo(CCharactor *pOther,int side)
{
	m_Place[0] = pOther->m_Place[side];
	m_VVelocity[0] = pOther->m_VVelocity[side];
	m_Type[0] = pOther->m_Type[side];

	m_Speed = pOther->m_Speed;
	m_Jump = pOther->m_Jump;
	m_Gravity = pOther->m_Gravity;
}

void CCharactor::SetPos( CVector& V,int side )
{
	m_Place[side] = V;
}

void CCharactor::DrawName( CDirectDrawSurface* pBack,int x,int y)
{
	HDC hdc;
	pBack->GetDC(&hdc);
		SetBkColor(hdc,RGB(0,0,0));
		SetTextColor(hdc,RGB(255,255,255));
		TextOut(hdc,x,y,m_Name,strlen(m_Name));
	pBack->ReleaseDC(hdc);
}

void CCharactor::Draw(CDirectDrawSurface *pBack,int side)
{
	RECT rcTo = { (int)m_Place[side].x-24 , (int)m_Place[side].y-48 , 
					(int)m_Place[side].x+24 , (int)m_Place[side].y };
	RECT rcFrom = {0,0,48,48};
	if( side==1 )
	{
		rcFrom.left=48;	rcFrom.right=96;
	}

	if( rcTo.top<FieldRect.top || rcTo.bottom>FieldRect.bottom ||
			rcTo.left<FieldRect.left || rcTo.right>FieldRect.right )
		return;

	if( m_pSurf!=NULL )
		pBack->Blt( &rcTo , m_pSurf , &rcFrom , DDBLT_WAIT|DDBLT_KEYSRC , NULL );
}


int CCharactor::WhichWin(CCharactor *A, CCharactor *B)
{
	CVector Dif = A->m_Place[0] - B->m_Place[1];

	// Wł݂ďdȂĂȂ牽B
	if( !(-30<Dif.x && Dif.x<30) )
		return 0;

	// `̕ŁȂxanʂɂ`̏
	if( -48<Dif.y && Dif.y<-24 )
	{
		if( B->m_Place[1].y==EarthHeight || 
				A->m_VVelocity[0] > B->m_VVelocity[1] )
			return -1;
	}
	// a̕ŁȂx`nʂɂȁ
	else if( 24<Dif.y && Dif.y<48 )
	{
		if( A->m_Place[0].y==EarthHeight || 
				B->m_VVelocity[1] > A->m_VVelocity[0] )
			return 1;
	}
	// dȂĂ炸炵܂
	else if( -48<Dif.x && Dif.x<48 && -48<Dif.y && Dif.y<48 )
	{
//		A->m_Place.x += ( 48-fabs(Dif.x) )/2 * Dif.x/fabs(Dif.x);
//		B->m_Place.x -= ( 48-fabs(Dif.x) )/2 * Dif.x/fabs(Dif.x);
		A->m_Place[0].x += ( 48/fabs(Dif.x) - 1 )*Dif.x/2;
		B->m_Place[1].x -= ( 48/fabs(Dif.x) - 1 )*Dif.x/2;
	}

	// Җ
	return 0;
}

void CCharactor::Clip( CCharactor* A,int side )
{
	if( A->m_Place[side].x > FieldRect.right-24 )
		A->m_Place[side].x = FieldRect.right-24;
	if( A->m_Place[side].x < FieldRect.left+24 )
		A->m_Place[side].x = FieldRect.left+24;
	if( A->m_Place[side].y > EarthHeight )
		A->m_Place[side].y = EarthHeight;
}

void CCharactor::Act(clock_t ms,int side)
{
	// vlʁi͌ʁj𔽉fړ
	double SpeedK,JumpK;	// 萔
	if( m_Tactics[side] & DUSH )
	{
		if( m_Place[side].y < EarthHeight )	SpeedK = 2;
		else								SpeedK = 2;
		JumpK = 1.2;
	}
	else
	{
		if( m_Place[side].y < EarthHeight )	SpeedK = 1;
		else								SpeedK = 1;
		JumpK = 1;
	}

	if( m_Tactics[side] & RIGHT )
		m_Place[side].x += SpeedK*m_Speed*ms/1000;
	if( m_Tactics[side] & LEFT )
		m_Place[side].x -= SpeedK*m_Speed*ms/1000;
	if( m_Tactics[side] & JUMP )
	{
		if( m_Place[side].y == EarthHeight )
		{
			pBoon->Play();
			m_VVelocity[side] = JumpK*m_Jump;
		}
	}

	// 󒆂̗
	m_Place[side].y += m_VVelocity[side]*ms/1000;
	m_VVelocity[side] += m_Gravity*ms/1000;
}

void CCharactor::Think(char *Key, CCharactor *pEnemy,int side)
{
	m_Tactics[side] = 0;

	// LN^[Ƃ̏
	// G̃TCh͏0łB
	switch( m_Type[side] )
	{
	case KEY1:
		{
			if( Key[DIK_S] != 0 )	m_Tactics[side] |= LEFT;
			if( Key[DIK_F] != 0 )	m_Tactics[side] |= RIGHT;
			if( Key[DIK_D] != 0 )	m_Tactics[side] |= DUSH;
			if( Key[DIK_E] != 0 )	m_Tactics[side] |= JUMP;
		}
		break;
	case KEY2:
		{
			if( Key[DIK_LEFT] != 0 )	m_Tactics[side] |= LEFT;
			if( Key[DIK_RIGHT] != 0 )m_Tactics[side] |= RIGHT;
			if( Key[DIK_DOWN] != 0 )	m_Tactics[side] |= DUSH;
			if( Key[DIK_UP] != 0 )	m_Tactics[side] |= JUMP;
		}
		break;
	case COM1://^[
		{
			CVector Dif = pEnemy->m_Place[0] - m_Place[side];
			if( Dif.x <= 0 )	m_Tactics[side] |= LEFT;
			if( Dif.x >= 0 )	m_Tactics[side] |= RIGHT;
			m_Tactics[side] |= JUMP;
		}
		break;
	case COM2://W[
		{
			CVector Dif = pEnemy->m_Place[0] - m_Place[side];
			if( Dif.x <= 0 )	m_Tactics[side] |= LEFT;
			if( Dif.x >= 0 )	m_Tactics[side] |= RIGHT;
			m_Tactics[side] |= (JUMP|DUSH);
		}
		break;
	case COM3://Tu
		{
			CVector Dif = pEnemy->m_Place[0] - m_Place[side];

			if( Dif.y >= 0 )
			{
				m_Tactics[side] |= JUMP;
				if( Dif.x <= 0 )	m_Tactics[side] |= LEFT;
				if( Dif.x >= 0 )	m_Tactics[side] |= RIGHT;
			}
			else
			{
				if( Dif.x <= 0 )	m_Tactics[side] |= RIGHT;
				if( Dif.x >= 0 )	m_Tactics[side] |= LEFT;
			}
		}
		break;
	case COM4://{
		{
			CVector Dif = pEnemy->m_Place[0] - m_Place[side];
			switch( rand()%3 )
			{
			case 0:
				m_Tactics[side] |= LEFT;
				break;
			case 1:
				m_Tactics[side] |= RIGHT;
				break;
			}
			if( rand()%2==0 )	m_Tactics[side] |= DUSH;
			if( rand()%20==0 )	m_Tactics[side] |= JUMP;
		}
		break;
	case COM5://
		{
			CVector Dif = pEnemy->m_Place[0] - m_Place[side];

			if( EarthHeight-pEnemy->m_Place[0].y<40 )
				m_Tactics[side]|=JUMP;

			if( Dif.y < 0 && Dif.x*Dif.x<100*100 )
			{
				if( Dif.x<=0 )
				{
					if( Dif.x*Dif.x<24*24 && (FieldRect.left+FieldRect.right)/2<m_Place[side].x )
						m_Tactics[side]|=(LEFT|DUSH);
					else
						m_Tactics[side]|=RIGHT;
				}
				else
				{
					if( Dif.x*Dif.x<24*24 && (FieldRect.left+FieldRect.right)/2>m_Place[side].x )
						m_Tactics[side]|=(RIGHT|DUSH);
					else
						m_Tactics[side]|=LEFT;
				}
			}
			else if( Dif.x*Dif.x<100*100 )
			{
				if( Dif.x<=0 )	m_Tactics[side]|=LEFT;
				if( Dif.x>=0 )	m_Tactics[side]|=RIGHT;
			}
		}
		break;
	case COM6://Ag
		{
			CVector Dif = pEnemy->m_Place[0] - m_Place[side];

			if( abs(Dif) < 220 )
				m_Tactics[side] |= DUSH;
			if( (pEnemy->m_Place[0].y < EarthHeight
					&& pEnemy->m_VVelocity[0] > 0 && Dif.x*Dif.x > 50*50) ||
				(Dif.x*Dif.x < 50*50 && pEnemy->m_Place[0].y == EarthHeight ) )
				m_Tactics[side] |= JUMP;

			if( Dif.x*Dif.x < 20*20 && Dif.y > 0 )
				break;

			else if( Dif.x <= -90 || (Dif.y<0&&0<Dif.x&&Dif.x<50) || (Dif.y>0&&Dif.x<0) )
				m_Tactics[side] |= LEFT;
			else if( Dif.x > 90   || (Dif.y<0&&-50<Dif.x&&Dif.x<0) || (Dif.y>0&&0<Dif.x) )
				m_Tactics[side] |= RIGHT;
		}
		break;
	case COM7://S}
		{
			static bool bLeft = true;

			CVector Dif = pEnemy->m_Place[0] - m_Place[side];

			if( bLeft )			m_Tactics[side]|=RIGHT;
			else				m_Tactics[side]|=LEFT;
			if( m_Place[side].x-24==FieldRect.left ) bLeft=false;
			if( m_Place[side].x+24==FieldRect.right ) bLeft=true;

			if( -200<Dif.x && Dif.x<0 && bLeft )	m_Tactics[side]|=JUMP;
			if( 0<Dif.x && Dif.x<200 && !bLeft )	m_Tactics[side]|=JUMP;
		}
		break;
	case COM8://
		{
			CVector myP = m_Place[side];
			CVector enP = pEnemy->m_Place[0];
			CVector Dif = enP - myP;
			CVector ADf = CVector( Dif.x<0 ? -Dif.x : Dif.x,
									 Dif.y<0 ? -Dif.y : Dif.y,
									 0 );
			double myV = m_VVelocity[side];
			double enV = pEnemy->m_VVelocity[0];
			int lt = FieldRect.left;
			int rt = FieldRect.right;
			int bm = EarthHeight;

			m_Tactics[side]|=DUSH;

			if( Dif.y<0 )
			{
				if( ADf.x > ADf.y+48 )
				{
					// U߂
					if( enV>0 && bm-enP.y<100 )
						m_Tactics[side]|=JUMP;
					if( Dif.x<0 )	m_Tactics[side]|=LEFT;
					if( Dif.x>0 )	m_Tactics[side]|=RIGHT;
				}
				else
				{
					// 
					if( Dif.x<=0 )
					{
						if( ADf.x<48 && FieldRect.right<50+myP.x )
							m_Tactics[side]|=LEFT;
						else
							m_Tactics[side]|=RIGHT;
						if( ADf.x>48 )
							m_Tactics[side]|=JUMP;
					}
					else
					{
						if( ADf.x<48 && FieldRect.left>myP.x-50)
							m_Tactics[side]|=RIGHT;
						else
							m_Tactics[side]|=LEFT;
						if( ADf.x>48 )
							m_Tactics[side]|=JUMP;
					}
				}
			}
			else if( Dif.y==0 )
			{
				if( Dif.x<0 )
					m_Tactics[side]|=LEFT;
				if( Dif.x>0 )
					m_Tactics[side]|=RIGHT;
				if( ADf.x < 60 )
					m_Tactics[side]|=JUMP;
			}
			else
			{
				if( Dif.x<0 )
					m_Tactics[side]|=LEFT;
				if( Dif.x>0 )
					m_Tactics[side]|=RIGHT;
			}
		}
		break;
	}
}
