// Vector.h: CVector NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_VECTOR_H__4CE1DEE2_95C6_11D2_B316_D20DEBDFFB38__INCLUDED_)
#define AFX_VECTOR_H__4CE1DEE2_95C6_11D2_B316_D20DEBDFFB38__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CVector
{
public:
	// RXgN^
	CVector()							{ x=0 , y=0 , z=0; };
	CVector(double X,double Y,double Z)	{ x=X , y=Y , z=Z; };
	CVector(CVector& V)					{ x=V.x , y=V.y , z=V.z; };
	CVector(D3DVECTOR& D)				{ x=D.x , y=D.y , z=D.z; };
	// fXgN^
	virtual ~CVector();

	// LXg
	operator D3DVECTOR()
		{ D3DVECTOR D = {D3DVAL(x),D3DVAL(y),D3DVAL(z)}; return D; };
	// 
	CVector operator - ()
		{ return CVector(-x, -y, -z); };

	// Z
	CVector& operator += (const CVector& v)
		{ x+=v.x; y+=v.y; z+=v.z; return *this;};
	CVector& operator -= (const CVector& v)
		{ x-=v.x; y-=v.y; z-=v.z; return *this;};
	CVector& operator *= (double s)
		{ x*=s; y*=s; z*=s; return *this;};
	CVector& operator /= (double s)
		{ x/=s; y/=s; z/=s; return *this;};
	CVector& operator = (const D3DVECTOR& D)
		{ x = D.x; y = D.y; z = D.z; return *this; };

	// ̑֗Ȋ֐
	void SetSize( double s );
	CVector GenerateUp();
	bool IsSameWay( CVector& V );

	// f[^o
	double x;
	double y;
	double z;
};

// r
inline int operator == (const CVector& v1, const CVector& v2)
		{ return (v1.x==v2.x && v1.y==v2.y && v1.z==v2.z); };
// aE
inline CVector operator - (const CVector& v1, const CVector& v2)
		{ return CVector(v1.x-v2.x, v1.y-v2.y, v1.z-v2.z); };
inline CVector operator + (const CVector& v1, const CVector& v2)
		{ return CVector(v1.x+v2.x, v1.y+v2.y, v1.z+v2.z); };
// {
inline CVector operator * (const CVector& v, double s)
		{ return CVector( v.x*s , v.y*s , v.z*s ); };
inline CVector operator * (double s, const CVector& v)
		{ return CVector( s*v.x , s*v.y , s*v.z ); };
inline CVector operator / (const CVector& v, double s)
		{ return CVector( v.x/s , v.y/s , v.z/s ); };
// O
inline CVector operator * (const CVector& v1, const CVector& v2)
		{ return CVector( v1.y*v2.z-v1.z*v2.y ,
				v1.z*v2.x-v1.x*v2.z , v1.x*v2.y-v1.y*v2.x); };
// 
inline double Dot(const CVector& v1, const CVector& v2)
		{ return ( v1.x*v2.x + v1.y*v2.y + v1.z*v2.z ); };
// Βl
double abs(CVector& V);

#endif // !defined(AFX_VECTOR_H__4CE1DEE2_95C6_11D2_B316_D20DEBDFFB38__INCLUDED_)
